%%% This is a demo how to use the IB script.
%%% here are examples of input files:
%
%
% joint-histogram.csv
%
% FROMTO,I   ,ii   ,iii ,IV  ,V   ,vi  ,viio
% I     ,0   ,392  ,14  ,582 ,896 ,262 ,106
% ii    ,12  ,0    ,15  ,5   ,674 ,17  ,182
% iii   ,13  ,6    ,0   ,44  ,12  ,32  ,3
% IV    ,239 ,134  ,16  ,0   ,380 ,13  ,173
% V     ,2099,25   ,46  ,93  ,0   ,211 ,2
% vi    ,96  ,206  ,25  ,95  ,172 ,0   ,36
% viio  ,499 ,1    ,4   ,9   ,24  ,20  ,0
%
% predetermined-categories.csv
%
% CHORD ,Mmd        ,TSD
% I     ,Major      ,Tonic
% ii    ,minor      ,Subdominant
% iii   ,minor      ,Tonic
% IV    ,Major      ,Subdominant
% V     ,Major      ,Dominant
% vi    ,minor      ,Tonic
% viio  ,diminished ,Dominant

clear all;close all;clc %"To begin at the beginning, It is Spring, moonless night in the small town..." 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% This is the only thing one need to change inorder to run the script.
% set parameters:
param.fname_data='input/joint_histogram.csv';  %joint histogram: past is in rows futre is in columns.
param.fname_pre_determined_clusters='input/pre_determined_clusters.csv'; %pre-determined clusters file The firts column of this file should be identical to the joint histogram (same names of tokens)
param.ITER_infocurve=20; %how much iteration to compute info-curve (could be fast because this converge efficently)
param.ITER_clusters=200; %how much iteration to compute determinsitic clusters (more iterationa because of local minima)
param.KS=[2 3 4 5 6 7]; %determinisitc categories
param.KS_betaS=[120 150 150 150 150 150]; %beta of determinsitc categories (default [] is 120 for 2-clusters and 150 otherwise) should be either [] or the same size as KS
param.beta_range=[80 1.1000]; %range of beta values for the optimization [if the info curve do not "end" in 0 or maximum change the minimum or maximum
param.beta_jump=0.5000; %(size of jump in beta values) in logarithmic units if you want more dense infocurve reduce this value
param.name_of_dataset='My dataset'; % used only when VERBOSE is high (not used in console mode)

%set verbosity level
% param.VERBOSE=.5;   %only run results (do not plot anything)
param.VERBOSE=11;     %print and draw graphs

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% the results are agregated in a very long STRUCT. 
RESULT=IBLIB_MAIN_run_all_as_function(param);

fprintf('\nplot final results...\n');
% an example how to plot information curve.
IBLIIB_doplot(RESULT.NZ,RESULT.CATZ_NAMEs,RESULT.KS,RESULT.ICXs,RESULT.IYCs,RESULT.tICXs,RESULT.tIYCs,RESULT.kICXs,RESULT.kIYCs,RESULT.IYX,RESULT.VERBOSE)

fprintf('\n\nprint final categories...\n');
% an example how print all resulting categories
IBLIB_print_all_clusters(RESULT.tPCXs,RESULT.tICXs,RESULT.tIYCs,RESULT.kPCXs,RESULT.kICXs,RESULT.kIYCs,RESULT.x,RESULT.NAMESX,RESULT.FUNCZs,RESULT.CATZ_NAMEs,RESULT.NZ,RESULT.KS)

% additional important variables are:
%RESULT.PCXs - a cell array with all mappings of tokens to clusters of the info curve
%RESULT.tPCXs - a cell array with all predetermined mappings of tokens to clusters 
%RESULT.tPCXs - a cell array with all optimal determinsitic mappings of tokens to clusters 
%RESULT.NAMESX names of tokens (X)
%RESULT.NAMESY names of tokens (Y)
%RESULT.pyx joint probablity
%RESULT.PYX p(Y|X) (conditional probabilties)
%RESULTS.x RESULTS.y marginals distrebutions                