% preform ITER iteration of the Tishby et al. (1999) iterations
% x and y are the marginal distrebutions.
% PCX=P(C|X) the mapping between X and the clusters C.
% PTY is not used in this function and is set only for compatibility with
% another part of the library
% mybeta is the current beta value
% ITER in the nuber of iterations to do
function [PCX,PTY,PTC,PYC,L]=IBLIB_do_IB_iteration(x,y,PCX,PTY,PYX,mybeta,ITER)


%make iterations
for kk=1:ITER,
    %step A
    c=PCX*x;
    PYC=(PYX.*repmat( x' ,[size(PYX,1),1]))* (((PCX).*repmat(  1./(c+eps)  ,[1,size(PCX,2)]))' );
    
    d1=repmat(sum(PYX.*log(PYX+eps)),size(PCX,1),1);
    d2=(-log(PYC'+eps))*PYX;
    DKL=d1+d2;
    
    PCX=exp(-mybeta*(DKL)).*repmat(c,1,length(x));
    PCX=PCX./repmat(sum(PCX),size(PCX,1),1);
    PCX(isnan(PCX))=0;
end


%make predictions distrebutions
if length(x)==length(y)
    PTY=PCX;
else
    PTY=eye(length(y),length(y));
end


c=PCX*x;
PXC=(PCX').*repmat(x,[1 size(PCX,1)]).*repmat((1./(c+eps))' , [size(PCX,2) 1]);
PYC=PYX*PXC;
[ICX,ITY,ITC,IYC,IYX]=IBLIB_calc_info(x,y,PCX,PTY,PYX);
L=ICX-mybeta*IYC;

if length(x)==length(y)
    PTC=PTY*PYX*PXC;
else
    PTC=[];
end

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% OLD WORKS ONLY FOR SYMETRIC CASESS (length(x)=length(y)) do not use!
%   assert(length(x)==length(y));
%   PTY=eye(length(y),length(y));
%
%   for kk=1:ITER,
%       %step A
%       c=PCX*x;
%       PTC=PTY*(PYX.*repmat( x' ,[size(PYX,1),1]))*(((PCX).*repmat(  1./(c+eps)  ,[1,size(PCX,2)]))');
%       PTX=PTY*PYX;
%
%       d1=repmat(sum(PTX.*log(PTX+eps)),size(PCX,1),1);
%       d2=(-log(PTC'+eps))*PTX;
%       DKL=d1+d2;
%
%       PCX=exp(-mybeta*(DKL)).*repmat(c,1,length(x));
%       PCX=PCX./repmat(sum(PCX),size(PCX,1),1);
%
%       %step B
%       PTY=eye(length(y),length(y));
%   end
%
%   % calculate finalstates assuming PCX and PTY are the same.
%   PTY=PCX;
%   c=PCX*x;
%   PXC=(PCX').*repmat(x,[1 size(PCX,1)]).*repmat((1./(c+eps))' , [size(PCX,2) 1]);
%   PTC=PTY*PYX*PXC;
%   PYC=PYX*PXC;
%
%   [ICX,ITY,ITC,IYC,IYX]=IBLIB_calc_info(x,y,PCX,PTY,PYX);
%   L=ICX-mybeta*IYC;
%
%
%   end
%
%

