% This function compute a vraint of Tishby et al. algorithm
% it runs a batch of KS values that are the number of optimal deterministic clusters to compure
% x, y are the marginals; PCX0 initial cluster assignment also used to
% determine number of clusters (size(PCX0,1))
% PTY0 - not used here.
% PYX- P(Y|X)
% ITER number of total iteration per condition, total number of iteration
% is actually ITER*|Pertub_prob|*|what_to_do
% what_to_do- list of numbers like 1,2,3 where 1= start with original
% solution,2- permute original solution 3- randomize from scrach
% VERBOSE verbosity level, higher numbers more prints (typical value 13,10.5 and 0.5)
% betaS list of beta to work : note that betaS should be same length as KS
% NAMESX- string array with names of surface tokens (used for printing only).
function [PCXs,PTYs,PTCs,PYCs,bestLs,listLs,ICXs,ITYs,ITCs,IYCs,IYX]=IBLIB_run_batch_cluster_sizes(x,y,PYX,ITER,pertub_probS,temperatureS,what_to_do,VERBOSE,KS,betaS,NAMESX,session_header_forfiles);

DRAW_COND=false;

SS=KS;
assert(length(KS)==length(SS));    %SS is the number of clusters on Y 
assert(length(KS)==length(betaS)); % since betaS is the beta for each KS in older version this wasnot here, change the call.
if isempty(betaS)
    betaS=ones(size(KS))*120;
end
if length(betaS)<length(KS)
    betaS=ones(size(KS))*betaS(1);
end
if isempty(SS)
    SS=KS;
end
if isempty(temperatureS)
        temperatureS=[1e-10,100,1e-1,1,10,100 ,1e-5];
end
if isempty(pertub_probS)
        pertub_probS=[0.01 0.9 0.3 0.5 1 0.7 0.1];
end
if isempty(what_to_do)
 what_to_do=[1,2,2,2,2,3,3,3]; 
end

if isempty(ITER)
 ITER=200;
end
if isempty(VERBOSE)
 VERBOSE=11;
end

pTRESH=0.1;
pVERBOSE=0;

myVERBOSE=mod(VERBOSE,10);


NK=length(KS);
PCXs=cell(NK,1);
PTYs=cell(NK,1);
PTCs=cell(NK,1);
PYCs=cell(NK,1);
ICXs=zeros(NK,1);
ITYs=zeros(NK,1);
ITCs=zeros(NK,1);
IYCs=zeros(NK,1);

bestLs=zeros(NK,1);
listLs=cell(NK,1);

for k=1:NK,
    if VERBOSE>=0.5
        display(sprintf('...computing optimal clusters for K=%d (%d of %d)...',KS(k),k,NK))
    end
    
    PCX=zeros(KS(k),length(x));
    PTY=zeros(SS(k),length(y));
    for jj=1:length(x)   % random assignment to clusters
        PCX(mod(jj-1,KS(k))+1,jj)=1;
    end
    for jj=1:length(y) % random assignment to clusters
        PTY(mod(jj,SS(k))+1,jj)=1;
    end
    
    mybeta=betaS(k);

    [PCX,PTY,PTC,PYC,bL,Ls]=IBLIB_do_annealing(x,y,PCX,PTY,PYX,mybeta,ITER,pertub_probS,temperatureS,what_to_do,myVERBOSE,NAMESX);
    if (isempty(PTC))
        PTY=eye(length(y),length(y));
        PTC=0;
        
    end
    assert(~isempty(PCX));
    assert(~isempty(PTY));
    PCXs{k}=PCX;
    PTYs{k}=PTY;
    PTCs{k}=PTC;
    PYCs{k}=PYC;
    bestLs(k)=bL;
    listLs{k}=Ls;
    
    [ICX,ITY,ITC,IYC,IYX]=IBLIB_calc_info(x,y,PCXs{k},PTYs{k},PYX);
    ICXs(k)=ICX;
    ITYs(k)=ITY;
    ITCs(k)=ITC;
    IYCs(k)=IYC;
    c=PCX*x;
    t=PTY*y;
    PYCX=(PYC*PCX).*repmat(x',[size(PYX,1) 1]);
    
    if ~isempty(session_header_forfiles)
       if k==1
        dlmwrite(sprintf('%sclusters.PYX.csv',session_header_forfiles),PYX,'delimiter',',','precision',5);
       end
        msg2=sprintf('%d',k);msgk='00000';msgk((end-length(msg2)+1):end)=msg2(:);
        dlmwrite(sprintf('%sclusters.%s.PCX.csv',session_header_forfiles,msgk),PCX,'delimiter',',','precision',3);
        dlmwrite(sprintf('%sclusters.%s.PTC.csv',session_header_forfiles,msgk),PTC,'delimiter',',','precision',3);
        dlmwrite(sprintf('%sclusters.%s.PCYX.csv',session_header_forfiles,msgk),PYCX,'delimiter',',','precision',3);
       if length(Ls)>1000
            Ls_toprint=[Ls(1:4:399),ones(1,3)*mean(Ls),Ls((end-399):4:end)];
        elseif length(Ls)>2000
            Ls_toprint=[Ls(1:1000),ones(1,30)*mean(Ls),Ls((end-1000):end)];
        else
            Ls_toprint=Ls;
        end
        dlmwrite(sprintf('%sclusters.%s.scores.csv',session_header_forfiles,msgk),Ls_toprint,'delimiter',',','precision',3);
        INFOPOINTS=[ICXs(1:k),IYCs(1:k),IYX*ones(size(ICXs(1:k)))];
        dlmwrite(sprintf('%sclusters.%s.tempinfopoints.csv',session_header_forfiles,msgk),INFOPOINTS,'delimiter',',','precision',5);
        FIT=fopen(sprintf('%sclusters.%s.string.csv',session_header_forfiles,msgk),'w+');
            [~,~,msgBB]=IBLIB_print_clusters(PCX,x,NAMESX,0.1,1,[]);
            fprintf(FIT,'%s\n',msgBB);
        fclose(FIT);
    end
    
    if VERBOSE>=10
        c=PCX*x;
        t=PTY*y;
        [~,idxC]=sort(c);
        [~,idxT]=sort(t);
        %[~,idxC]=sort(PCX*((1:length(x))'));
        
        figure(20);clf;
%        maxwindow; %download maxwindow from internet/ or delet this line [this will work only on windows]
        
        
        subplot(3,2,1);
        %imagesc(PCX(:,:),[0 1]);axis xy;
		imagesc(PCX(:,:));axis xy;
        %imagesc(PCX(idxC,:),[0 1]);axis xy;
        [msgA,~]=IBLIB_print_clusters(PCX,x,NAMESX,pTRESH,pVERBOSE,[]);
        if VERBOSE>=0.5
            display(sprintf('.... found optimal clusters:%s',msgA))
        end
        if (length(msgA)<50)
            title(sprintf('PCX: %s',msgA));
        else
            title(sprintf('PCX(clusters assignment)'));
        end
                
        subplot(3,2,2);
        imagesc(PTC(:,:),[0 1]);axis xy;
        %imagesc(PTC(idxT,idxC),[0 1]);axis xy;
        title('PTC(cluster to next cluster)');
        
        subplot(3,2,3);
         if DRAW_COND
            imagesc(PYC*PCX,[0 1]);axis xy;
            title('PYCX (prediction)');
         else
             imagesc((PYC*PCX).*repmat(x',[size(PYX,1) 1]));axis xy;
             title('P_C(Y,X) (predicted distribution)');
         end
        subplot(3,2,4);
        if DRAW_COND
            %imagesc(PYX,[0 1]);axis xy;
			imagesc(PYX);axis xy;
            title('PYX');
        else
            imagesc(PYX.*repmat(x',[size(PYX,1) 1]));axis xy;
            title('P(Y,X) (real distribution)');
        end
        
        subplot(3,2,5);
        plot(1:length(Ls),Ls,'b-','LineWidth',2);hold on;
        plot(1:length(Ls),bL,'r-','LineWidth',2);
        title(sprintf('Lagrangian  values for beta=%g',mybeta));
        xlabel('iteration');
        ylabel('Lagrangian values');
        
        subplot(3,2,6);
        plot(ICXs(1:k),IYCs(1:k),'bo-','LineWidth',2);hold on;
        plot([0,max(ICXs)],[IYX IYX], 'g-','LineWidth',3);
        axis([0,max(ICXs),0, IYX]);
        xlabel('I(X;C)');
        ylabel('I(Y;C)');
        title('Information plane');
        
        
        drawnow;
    end
end

INFOPOINTS=[ICXs,IYCs,IYX*ones(size(ICXs)),KS'];
if ~isempty(session_header_forfiles)
        dlmwrite(sprintf('%sclusters.infocurve.DONE.csv',session_header_forfiles),INFOPOINTS,'delimiter',',','precision',5);
end


end
       